/*
 * This file is part of PySide: Python for Qt
 *
 * Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 *
 * Contact: PySide team <contact@pyside.org>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA
 *
 */


//workaround to access protected functions
#define protected public

// default includes
#include <shiboken.h>
#include <vector>
#include <algorithm>
#include <qsignal.h>
#include <qproperty.h>
#include <pyside.h>
#include <typeresolver.h>
#include <typeinfo>
#include "qtmobility_contacts_python.h"

#include "qtmobility_qcontactdetaildefinition_wrapper.h"

// Extra includes
#include <QMap>
#include <qcontactdetaildefinition.h>
#include <qcontactdetailfielddefinition.h>

using namespace Shiboken;
using namespace QtMobility;


// Target ---------------------------------------------------------

extern "C" {
static int
SbkQtMobility_QContactDetailDefinition_Init(PyObject* self, PyObject* args, PyObject* kwds)
{
    if (Shiboken::isUserType(self) && !Shiboken::canCallConstructor(self->ob_type, Shiboken::SbkType<QtMobility::QContactDetailDefinition >()))
        return -1;

    QtMobility::QContactDetailDefinition* cptr = 0;
    int overloadId = -1;
    SbkBaseWrapper* sbkSelf = reinterpret_cast<SbkBaseWrapper*>(self);


    int numArgs = PyTuple_GET_SIZE(args);
    PyObject* arg = 0;

    // invalid argument lengths


    if (!PyArg_UnpackTuple(args, "QContactDetailDefinition", 0, 1, &arg))
        return -1;

    // Overloaded function decisor
    // 0: QContactDetailDefinition()
    // 1: QContactDetailDefinition(QtMobility::QContactDetailDefinition)
    if (numArgs == 0) {
        overloadId = 0; // QContactDetailDefinition()
    } else if (numArgs == 1 && Shiboken::Converter<const QtMobility::QContactDetailDefinition & >::isConvertible(arg)) {
        overloadId = 1; // QContactDetailDefinition(QtMobility::QContactDetailDefinition)
    }

    // Function signature not found.
    if (overloadId == -1) goto SbkQtMobility_QContactDetailDefinition_Init_TypeError;

    // Call function/method
    {
        switch (overloadId) {
            case 0: // QContactDetailDefinition()
            {

                if(!PyErr_Occurred()) {
                // QContactDetailDefinition()
                cptr = new QtMobility::QContactDetailDefinition();
                }
                break;
            }
            case 1: // QContactDetailDefinition(QtMobility::QContactDetailDefinition)
            {
                if (Shiboken::cppObjectIsInvalid(arg))
                    return -1;
                QtMobility::QContactDetailDefinition* cpp_arg0 = Shiboken::Converter<QtMobility::QContactDetailDefinition* >::toCpp(arg);

                if(!PyErr_Occurred()) {
                // QContactDetailDefinition(QtMobility::QContactDetailDefinition)
                cptr = new QtMobility::QContactDetailDefinition(*cpp_arg0);
                }
                break;
            }
        }
        }
    if (PyErr_Occurred() || !Shiboken::setCppPointer(sbkSelf, Shiboken::SbkType<QtMobility::QContactDetailDefinition >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (!cptr) goto SbkQtMobility_QContactDetailDefinition_Init_TypeError;

    sbkSelf->validCppObject = 1;
    BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;

    SbkQtMobility_QContactDetailDefinition_Init_TypeError:
        const char* overloads[] = {"", "QtMobility.Contacts.QtMobility::QContactDetailDefinition", 0};
        Shiboken::setErrorAboutWrongArguments(args, "QtMobility.Contacts.QContactDetailDefinition", overloads);
        return -1;
}

static PyObject* SbkQtMobility_QContactDetailDefinitionFunc_fields(PyObject* self)
{
    QtMobility::QContactDetailDefinition* cppSelf = 0;
    if (Shiboken::cppObjectIsInvalid(self))
        return 0;
    cppSelf = Shiboken::Converter<QtMobility::QContactDetailDefinition* >::toCpp(self);

    PyObject* pyResult = 0;

    // Call function/method
    {
        {

            if(!PyErr_Occurred()) {
            // fields()const
            QMap<QString, QtMobility::QContactDetailFieldDefinition > cppResult = cppSelf->QtMobility::QContactDetailDefinition::fields();
            pyResult = Shiboken::Converter<QMap<QString, QtMobility::QContactDetailFieldDefinition > >::toPython(cppResult);
            }
        }
        }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return 0;
    }
    return pyResult;
}

static PyObject* SbkQtMobility_QContactDetailDefinitionFunc_insertField(PyObject* self, PyObject* args)
{
    QtMobility::QContactDetailDefinition* cppSelf = 0;
    if (Shiboken::cppObjectIsInvalid(self))
        return 0;
    cppSelf = Shiboken::Converter<QtMobility::QContactDetailDefinition* >::toCpp(self);

    int overloadId = -1;
    int numArgs = PyTuple_GET_SIZE(args);
    PyObject* pyargs[] = {0, 0};

    // invalid argument lengths


    if (!PyArg_UnpackTuple(args, "insertField", 2, 2, &(pyargs[0]), &(pyargs[1])))
        return 0;


    // Overloaded function decisor
    // 0: insertField(QString,QtMobility::QContactDetailFieldDefinition)
    if (numArgs == 2 && Shiboken::Converter<QString >::isConvertible(pyargs[0]) && Shiboken::Converter<const QtMobility::QContactDetailFieldDefinition & >::isConvertible(pyargs[1])) {
        overloadId = 0; // insertField(QString,QtMobility::QContactDetailFieldDefinition)
    }

    // Function signature not found.
    if (overloadId == -1) goto SbkQtMobility_QContactDetailDefinitionFunc_insertField_TypeError;

    // Call function/method
    {
        {
            QString cpp_arg0 = Shiboken::Converter<QString >::toCpp(pyargs[0]);
            if (Shiboken::cppObjectIsInvalid(pyargs[1]))
                return 0;
            QtMobility::QContactDetailFieldDefinition* cpp_arg1 = Shiboken::Converter<QtMobility::QContactDetailFieldDefinition* >::toCpp(pyargs[1]);

            if(!PyErr_Occurred()) {
            // insertField(QString,QtMobility::QContactDetailFieldDefinition)
            cppSelf->QtMobility::QContactDetailDefinition::insertField(cpp_arg0, *cpp_arg1);
            }
        }
        }

    if (PyErr_Occurred()) {
        return 0;
    }
    Py_RETURN_NONE;

    SbkQtMobility_QContactDetailDefinitionFunc_insertField_TypeError:
        const char* overloads[] = {"QString, QtMobility.Contacts.QtMobility::QContactDetailFieldDefinition", 0};
        Shiboken::setErrorAboutWrongArguments(args, "QtMobility.Contacts.QContactDetailDefinition.insertField", overloads);
        return 0;
}

static PyObject* SbkQtMobility_QContactDetailDefinitionFunc_isEmpty(PyObject* self)
{
    QtMobility::QContactDetailDefinition* cppSelf = 0;
    if (Shiboken::cppObjectIsInvalid(self))
        return 0;
    cppSelf = Shiboken::Converter<QtMobility::QContactDetailDefinition* >::toCpp(self);

    PyObject* pyResult = 0;

    // Call function/method
    {
        {

            if(!PyErr_Occurred()) {
            // isEmpty()const
            bool cppResult = cppSelf->QtMobility::QContactDetailDefinition::isEmpty();
            pyResult = Shiboken::Converter<bool >::toPython(cppResult);
            }
        }
        }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return 0;
    }
    return pyResult;
}

static PyObject* SbkQtMobility_QContactDetailDefinitionFunc_isUnique(PyObject* self)
{
    QtMobility::QContactDetailDefinition* cppSelf = 0;
    if (Shiboken::cppObjectIsInvalid(self))
        return 0;
    cppSelf = Shiboken::Converter<QtMobility::QContactDetailDefinition* >::toCpp(self);

    PyObject* pyResult = 0;

    // Call function/method
    {
        {

            if(!PyErr_Occurred()) {
            // isUnique()const
            bool cppResult = cppSelf->QtMobility::QContactDetailDefinition::isUnique();
            pyResult = Shiboken::Converter<bool >::toPython(cppResult);
            }
        }
        }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return 0;
    }
    return pyResult;
}

static PyObject* SbkQtMobility_QContactDetailDefinitionFunc_name(PyObject* self)
{
    QtMobility::QContactDetailDefinition* cppSelf = 0;
    if (Shiboken::cppObjectIsInvalid(self))
        return 0;
    cppSelf = Shiboken::Converter<QtMobility::QContactDetailDefinition* >::toCpp(self);

    PyObject* pyResult = 0;

    // Call function/method
    {
        {

            if(!PyErr_Occurred()) {
            // name()const
            QString cppResult = cppSelf->QtMobility::QContactDetailDefinition::name();
            pyResult = Shiboken::Converter<QString >::toPython(cppResult);
            }
        }
        }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return 0;
    }
    return pyResult;
}

static PyObject* SbkQtMobility_QContactDetailDefinitionFunc_removeField(PyObject* self, PyObject* arg)
{
    QtMobility::QContactDetailDefinition* cppSelf = 0;
    if (Shiboken::cppObjectIsInvalid(self))
        return 0;
    cppSelf = Shiboken::Converter<QtMobility::QContactDetailDefinition* >::toCpp(self);

    int overloadId = -1;

    // Overloaded function decisor
    // 0: removeField(QString)
    if (Shiboken::Converter<QString >::isConvertible(arg)) {
        overloadId = 0; // removeField(QString)
    }

    // Function signature not found.
    if (overloadId == -1) goto SbkQtMobility_QContactDetailDefinitionFunc_removeField_TypeError;

    // Call function/method
    {
        {
            QString cpp_arg0 = Shiboken::Converter<QString >::toCpp(arg);

            if(!PyErr_Occurred()) {
            // removeField(QString)
            cppSelf->QtMobility::QContactDetailDefinition::removeField(cpp_arg0);
            }
        }
        }

    if (PyErr_Occurred()) {
        return 0;
    }
    Py_RETURN_NONE;

    SbkQtMobility_QContactDetailDefinitionFunc_removeField_TypeError:
        const char* overloads[] = {"QString", 0};
        Shiboken::setErrorAboutWrongArguments(arg, "QtMobility.Contacts.QContactDetailDefinition.removeField", overloads);
        return 0;
}

static PyObject* SbkQtMobility_QContactDetailDefinitionFunc_setFields(PyObject* self, PyObject* arg)
{
    QtMobility::QContactDetailDefinition* cppSelf = 0;
    if (Shiboken::cppObjectIsInvalid(self))
        return 0;
    cppSelf = Shiboken::Converter<QtMobility::QContactDetailDefinition* >::toCpp(self);

    int overloadId = -1;

    // Overloaded function decisor
    // 0: setFields(QMap<QString,QtMobility::QContactDetailFieldDefinition>)
    if (Shiboken::Converter< QMap<QString, QtMobility::QContactDetailFieldDefinition >  >::isConvertible(arg)) {
        overloadId = 0; // setFields(QMap<QString,QtMobility::QContactDetailFieldDefinition>)
    }

    // Function signature not found.
    if (overloadId == -1) goto SbkQtMobility_QContactDetailDefinitionFunc_setFields_TypeError;

    // Call function/method
    {
        {
            QMap<QString, QtMobility::QContactDetailFieldDefinition > cpp_arg0 = Shiboken::Converter<QMap<QString, QtMobility::QContactDetailFieldDefinition > >::toCpp(arg);

            if(!PyErr_Occurred()) {
            // setFields(QMap<QString,QtMobility::QContactDetailFieldDefinition>)
            cppSelf->QtMobility::QContactDetailDefinition::setFields(cpp_arg0);
            }
        }
        }

    if (PyErr_Occurred()) {
        return 0;
    }
    Py_RETURN_NONE;

    SbkQtMobility_QContactDetailDefinitionFunc_setFields_TypeError:
        const char* overloads[] = {"dict", 0};
        Shiboken::setErrorAboutWrongArguments(arg, "QtMobility.Contacts.QContactDetailDefinition.setFields", overloads);
        return 0;
}

static PyObject* SbkQtMobility_QContactDetailDefinitionFunc_setName(PyObject* self, PyObject* arg)
{
    QtMobility::QContactDetailDefinition* cppSelf = 0;
    if (Shiboken::cppObjectIsInvalid(self))
        return 0;
    cppSelf = Shiboken::Converter<QtMobility::QContactDetailDefinition* >::toCpp(self);

    int overloadId = -1;

    // Overloaded function decisor
    // 0: setName(QString)
    if (Shiboken::Converter<QString >::isConvertible(arg)) {
        overloadId = 0; // setName(QString)
    }

    // Function signature not found.
    if (overloadId == -1) goto SbkQtMobility_QContactDetailDefinitionFunc_setName_TypeError;

    // Call function/method
    {
        {
            QString cpp_arg0 = Shiboken::Converter<QString >::toCpp(arg);

            if(!PyErr_Occurred()) {
            // setName(QString)
            cppSelf->QtMobility::QContactDetailDefinition::setName(cpp_arg0);
            }
        }
        }

    if (PyErr_Occurred()) {
        return 0;
    }
    Py_RETURN_NONE;

    SbkQtMobility_QContactDetailDefinitionFunc_setName_TypeError:
        const char* overloads[] = {"QString", 0};
        Shiboken::setErrorAboutWrongArguments(arg, "QtMobility.Contacts.QContactDetailDefinition.setName", overloads);
        return 0;
}

static PyObject* SbkQtMobility_QContactDetailDefinitionFunc_setUnique(PyObject* self, PyObject* arg)
{
    QtMobility::QContactDetailDefinition* cppSelf = 0;
    if (Shiboken::cppObjectIsInvalid(self))
        return 0;
    cppSelf = Shiboken::Converter<QtMobility::QContactDetailDefinition* >::toCpp(self);

    int overloadId = -1;

    // Overloaded function decisor
    // 0: setUnique(bool)
    if (SbkNumber_Check(arg)) {
        overloadId = 0; // setUnique(bool)
    }

    // Function signature not found.
    if (overloadId == -1) goto SbkQtMobility_QContactDetailDefinitionFunc_setUnique_TypeError;

    // Call function/method
    {
        {
            bool cpp_arg0 = Shiboken::Converter<bool >::toCpp(arg);

            if(!PyErr_Occurred()) {
            // setUnique(bool)
            cppSelf->QtMobility::QContactDetailDefinition::setUnique(cpp_arg0);
            }
        }
        }

    if (PyErr_Occurred()) {
        return 0;
    }
    Py_RETURN_NONE;

    SbkQtMobility_QContactDetailDefinitionFunc_setUnique_TypeError:
        const char* overloads[] = {"bool", 0};
        Shiboken::setErrorAboutWrongArguments(arg, "QtMobility.Contacts.QContactDetailDefinition.setUnique", overloads);
        return 0;
}

static PyMethodDef SbkQtMobility_QContactDetailDefinition_methods[] = {
    {"fields", (PyCFunction)SbkQtMobility_QContactDetailDefinitionFunc_fields, METH_NOARGS},
    {"insertField", (PyCFunction)SbkQtMobility_QContactDetailDefinitionFunc_insertField, METH_VARARGS},
    {"isEmpty", (PyCFunction)SbkQtMobility_QContactDetailDefinitionFunc_isEmpty, METH_NOARGS},
    {"isUnique", (PyCFunction)SbkQtMobility_QContactDetailDefinitionFunc_isUnique, METH_NOARGS},
    {"name", (PyCFunction)SbkQtMobility_QContactDetailDefinitionFunc_name, METH_NOARGS},
    {"removeField", (PyCFunction)SbkQtMobility_QContactDetailDefinitionFunc_removeField, METH_O},
    {"setFields", (PyCFunction)SbkQtMobility_QContactDetailDefinitionFunc_setFields, METH_O},
    {"setName", (PyCFunction)SbkQtMobility_QContactDetailDefinitionFunc_setName, METH_O},
    {"setUnique", (PyCFunction)SbkQtMobility_QContactDetailDefinitionFunc_setUnique, METH_O},
    {0} // Sentinel
};

// Rich comparison
static PyObject* SbkQtMobility_QContactDetailDefinition_richcompare(PyObject* self, PyObject* other, int op)
{
    bool result = false;
    QtMobility::QContactDetailDefinition& cpp_self = *Shiboken::Converter<QtMobility::QContactDetailDefinition* >::toCpp(self);

    switch (op) {
        case Py_NE:
            if (Shiboken::Converter<const QtMobility::QContactDetailDefinition & >::isConvertible(other)) {
                // operator!=(const QtMobility::QContactDetailDefinition & other) const
                QtMobility::QContactDetailDefinition* cpp_other = Shiboken::Converter<QtMobility::QContactDetailDefinition* >::toCpp(other);
                result = !cpp_other ? cpp_self == Shiboken::Converter< QtMobility::QContactDetailDefinition  >::toCpp(other) : (cpp_self != (*cpp_other));
            } else goto SbkQtMobility_QContactDetailDefinition_RichComparison_TypeError;

            break;
        case Py_EQ:
            if (Shiboken::Converter<const QtMobility::QContactDetailDefinition & >::isConvertible(other)) {
                // operator==(const QtMobility::QContactDetailDefinition & other) const
                QtMobility::QContactDetailDefinition* cpp_other = Shiboken::Converter<QtMobility::QContactDetailDefinition* >::toCpp(other);
                result = !cpp_other ? cpp_self == Shiboken::Converter< QtMobility::QContactDetailDefinition  >::toCpp(other) : (cpp_self == (*cpp_other));
            } else goto SbkQtMobility_QContactDetailDefinition_RichComparison_TypeError;

            break;
        default:
            PyErr_SetString(PyExc_NotImplementedError, "operator not implemented.");
            return 0;
    }

    if (result)
        Py_RETURN_TRUE;
    SbkQtMobility_QContactDetailDefinition_RichComparison_TypeError:
    Py_RETURN_FALSE;

}

} // extern "C"

// Class Definition -----------------------------------------------
extern "C" {
static SbkBaseWrapperType SbkQtMobility_QContactDetailDefinition_Type = { { {
    PyObject_HEAD_INIT(&Shiboken::SbkBaseWrapperType_Type)
    /*ob_size*/             0,
    /*tp_name*/             "QtMobility.Contacts.QContactDetailDefinition",
    /*tp_basicsize*/        sizeof(Shiboken::SbkBaseWrapper),
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          &Shiboken::deallocWrapper,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        0,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_CHECKTYPES,
    /*tp_doc*/              0,
    /*tp_traverse*/         0,
    /*tp_clear*/            0,
    /*tp_richcompare*/      SbkQtMobility_QContactDetailDefinition_richcompare,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          SbkQtMobility_QContactDetailDefinition_methods,
    /*tp_members*/          0,
    /*tp_getset*/           0,
    /*tp_base*/             reinterpret_cast<PyTypeObject*>(&Shiboken::SbkBaseWrapper_Type),
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             SbkQtMobility_QContactDetailDefinition_Init,
    /*tp_alloc*/            0,
    /*tp_new*/              Shiboken::SbkBaseWrapper_TpNew,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
}, },
    /*mi_offsets*/          0,
    /*mi_init*/             0,
    /*mi_specialcast*/      0,
    /*type_discovery*/      0,
    /*obj_copier*/          0,
    /*ext_isconvertible*/   0,
    /*ext_tocpp*/           0,
    /*cpp_dtor*/            &Shiboken::callCppDestructor<QtMobility::QContactDetailDefinition >,
    /*is_multicpp*/         0,
    /*is_user_type*/        0,
    /*original_name*/       "QtMobility::QContactDetailDefinition",
    /*user_data*/           0
};
} //extern


void init_QtMobility_QContactDetailDefinition(PyObject* module)
{
    SbkQtMobility_ContactsTypes[SBK_QTMOBILITY_QCONTACTDETAILDEFINITION_IDX] = reinterpret_cast<PyTypeObject*>(&SbkQtMobility_QContactDetailDefinition_Type);

    if (PyType_Ready((PyTypeObject*)&SbkQtMobility_QContactDetailDefinition_Type) < 0)
        return;

    Py_INCREF(reinterpret_cast<PyObject*>(&SbkQtMobility_QContactDetailDefinition_Type));
    PyModule_AddObject(module, "QContactDetailDefinition",
        ((PyObject*)&SbkQtMobility_QContactDetailDefinition_Type));


    Shiboken::TypeResolver::createValueTypeResolver<QtMobility::QContactDetailDefinition >("QtMobility::QContactDetailDefinition");
    Shiboken::TypeResolver::createObjectTypeResolver<QtMobility::QContactDetailDefinition >("QtMobility::QContactDetailDefinition*");
    Shiboken::TypeResolver::createValueTypeResolver<QtMobility::QContactDetailDefinition >(typeid(QtMobility::QContactDetailDefinition).name());
    PySide::initQtMetaType<QtMobility::QContactDetailDefinition >();
}

