/*
 * This file is part of PySide: Python for Qt
 *
 * Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 *
 * Contact: PySide team <contact@pyside.org>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA
 *
 */


//workaround to access protected functions
#define protected public

// default includes
#include <shiboken.h>
#include <vector>
#include <algorithm>
#include <qsignal.h>
#include <qproperty.h>
#include <pyside.h>
#include <typeresolver.h>
#include <typeinfo>
#include "qtmobility_contacts_python.h"

#include "qtmobility_qcontactdetailrangefilter_wrapper.h"

// Extra includes
#include <qcontactfilter.h>

using namespace Shiboken;
using namespace QtMobility;


// Target ---------------------------------------------------------

extern "C" {
static int
SbkQtMobility_QContactDetailRangeFilter_Init(PyObject* self, PyObject* args, PyObject* kwds)
{
    if (Shiboken::isUserType(self) && !Shiboken::canCallConstructor(self->ob_type, Shiboken::SbkType<QtMobility::QContactDetailRangeFilter >()))
        return -1;

    QtMobility::QContactDetailRangeFilter* cptr = 0;
    int overloadId = -1;
    SbkBaseWrapper* sbkSelf = reinterpret_cast<SbkBaseWrapper*>(self);


    int numArgs = PyTuple_GET_SIZE(args);
    PyObject* arg = 0;

    // invalid argument lengths


    if (!PyArg_UnpackTuple(args, "QContactDetailRangeFilter", 0, 1, &arg))
        return -1;

    // Overloaded function decisor
    // 0: QContactDetailRangeFilter(QtMobility::QContactDetailRangeFilter)
    // 1: QContactDetailRangeFilter()
    // 2: QContactDetailRangeFilter(QtMobility::QContactFilter)
    if (numArgs == 0) {
        overloadId = 1; // QContactDetailRangeFilter()
    } else if (numArgs == 1 && Shiboken::Converter<const QtMobility::QContactFilter & >::isConvertible(arg)) {
        overloadId = 2; // QContactDetailRangeFilter(QtMobility::QContactFilter)
    } else if (numArgs == 1 && Shiboken::Converter<const QtMobility::QContactDetailRangeFilter & >::isConvertible(arg)) {
        overloadId = 0; // QContactDetailRangeFilter(QtMobility::QContactDetailRangeFilter)
    }

    // Function signature not found.
    if (overloadId == -1) goto SbkQtMobility_QContactDetailRangeFilter_Init_TypeError;

    // Call function/method
    {
        switch (overloadId) {
            case 0: // QContactDetailRangeFilter(QtMobility::QContactDetailRangeFilter)
            {
                if (Shiboken::cppObjectIsInvalid(arg))
                    return -1;
                std::auto_ptr<QtMobility::QContactDetailRangeFilter > cpp_arg0_auto_ptr;
                QtMobility::QContactDetailRangeFilter* cpp_arg0 = Shiboken::Converter<QtMobility::QContactDetailRangeFilter* >::toCpp(arg);
                if (!Shiboken::Converter<QtMobility::QContactDetailRangeFilter >::checkType(arg))
                    cpp_arg0_auto_ptr = std::auto_ptr<QtMobility::QContactDetailRangeFilter >(cpp_arg0);

                if(!PyErr_Occurred()) {
                // QContactDetailRangeFilter(QtMobility::QContactDetailRangeFilter)
                cptr = new QtMobility::QContactDetailRangeFilter(*cpp_arg0);
                }
                break;
            }
            case 1: // QContactDetailRangeFilter()
            {

                if(!PyErr_Occurred()) {
                // QContactDetailRangeFilter()
                cptr = new QtMobility::QContactDetailRangeFilter();
                }
                break;
            }
            case 2: // QContactDetailRangeFilter(QtMobility::QContactFilter)
            {
                if (Shiboken::cppObjectIsInvalid(arg))
                    return -1;
                QtMobility::QContactFilter* cpp_arg0 = Shiboken::Converter<QtMobility::QContactFilter* >::toCpp(arg);

                if(!PyErr_Occurred()) {
                // QContactDetailRangeFilter(QtMobility::QContactFilter)
                cptr = new QtMobility::QContactDetailRangeFilter(*cpp_arg0);
                }
                break;
            }
        }
        }
    if (PyErr_Occurred() || !Shiboken::setCppPointer(sbkSelf, Shiboken::SbkType<QtMobility::QContactDetailRangeFilter >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (!cptr) goto SbkQtMobility_QContactDetailRangeFilter_Init_TypeError;

    sbkSelf->validCppObject = 1;
    BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;

    SbkQtMobility_QContactDetailRangeFilter_Init_TypeError:
        const char* overloads[] = {"QtMobility.Contacts.QtMobility::QContactDetailRangeFilter", "", "QtMobility.Contacts.QtMobility::QContactFilter", 0};
        Shiboken::setErrorAboutWrongArguments(args, "QtMobility.Contacts.QContactDetailRangeFilter", overloads);
        return -1;
}

static PyObject* SbkQtMobility_QContactDetailRangeFilterFunc_detailDefinitionName(PyObject* self)
{
    QtMobility::QContactDetailRangeFilter* cppSelf = 0;
    if (Shiboken::cppObjectIsInvalid(self))
        return 0;
    cppSelf = Shiboken::Converter<QtMobility::QContactDetailRangeFilter* >::toCpp(self);

    PyObject* pyResult = 0;

    // Call function/method
    {
        {

            if(!PyErr_Occurred()) {
            // detailDefinitionName()const
            QString cppResult = cppSelf->QtMobility::QContactDetailRangeFilter::detailDefinitionName();
            pyResult = Shiboken::Converter<QString >::toPython(cppResult);
            }
        }
        }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return 0;
    }
    return pyResult;
}

static PyObject* SbkQtMobility_QContactDetailRangeFilterFunc_detailFieldName(PyObject* self)
{
    QtMobility::QContactDetailRangeFilter* cppSelf = 0;
    if (Shiboken::cppObjectIsInvalid(self))
        return 0;
    cppSelf = Shiboken::Converter<QtMobility::QContactDetailRangeFilter* >::toCpp(self);

    PyObject* pyResult = 0;

    // Call function/method
    {
        {

            if(!PyErr_Occurred()) {
            // detailFieldName()const
            QString cppResult = cppSelf->QtMobility::QContactDetailRangeFilter::detailFieldName();
            pyResult = Shiboken::Converter<QString >::toPython(cppResult);
            }
        }
        }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return 0;
    }
    return pyResult;
}

static PyObject* SbkQtMobility_QContactDetailRangeFilterFunc_matchFlags(PyObject* self)
{
    QtMobility::QContactDetailRangeFilter* cppSelf = 0;
    if (Shiboken::cppObjectIsInvalid(self))
        return 0;
    cppSelf = Shiboken::Converter<QtMobility::QContactDetailRangeFilter* >::toCpp(self);

    PyObject* pyResult = 0;

    // Call function/method
    {
        {

            if(!PyErr_Occurred()) {
            // matchFlags()const
            QFlags<QtMobility::QContactFilter::MatchFlag> cppResult = cppSelf->QtMobility::QContactDetailRangeFilter::matchFlags();
            pyResult = Shiboken::Converter<QFlags<QtMobility::QContactFilter::MatchFlag> >::toPython(cppResult);
            }
        }
        }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return 0;
    }
    return pyResult;
}

static PyObject* SbkQtMobility_QContactDetailRangeFilterFunc_maxValue(PyObject* self)
{
    QtMobility::QContactDetailRangeFilter* cppSelf = 0;
    if (Shiboken::cppObjectIsInvalid(self))
        return 0;
    cppSelf = Shiboken::Converter<QtMobility::QContactDetailRangeFilter* >::toCpp(self);

    PyObject* pyResult = 0;

    // Call function/method
    {
        {

            if(!PyErr_Occurred()) {
            // maxValue()const
            QVariant cppResult = cppSelf->QtMobility::QContactDetailRangeFilter::maxValue();
            pyResult = Shiboken::Converter<QVariant >::toPython(cppResult);
            }
        }
        }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return 0;
    }
    return pyResult;
}

static PyObject* SbkQtMobility_QContactDetailRangeFilterFunc_minValue(PyObject* self)
{
    QtMobility::QContactDetailRangeFilter* cppSelf = 0;
    if (Shiboken::cppObjectIsInvalid(self))
        return 0;
    cppSelf = Shiboken::Converter<QtMobility::QContactDetailRangeFilter* >::toCpp(self);

    PyObject* pyResult = 0;

    // Call function/method
    {
        {

            if(!PyErr_Occurred()) {
            // minValue()const
            QVariant cppResult = cppSelf->QtMobility::QContactDetailRangeFilter::minValue();
            pyResult = Shiboken::Converter<QVariant >::toPython(cppResult);
            }
        }
        }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return 0;
    }
    return pyResult;
}

static PyObject* SbkQtMobility_QContactDetailRangeFilterFunc_rangeFlags(PyObject* self)
{
    QtMobility::QContactDetailRangeFilter* cppSelf = 0;
    if (Shiboken::cppObjectIsInvalid(self))
        return 0;
    cppSelf = Shiboken::Converter<QtMobility::QContactDetailRangeFilter* >::toCpp(self);

    PyObject* pyResult = 0;

    // Call function/method
    {
        {

            if(!PyErr_Occurred()) {
            // rangeFlags()const
            QFlags<QtMobility::QContactDetailRangeFilter::RangeFlag> cppResult = cppSelf->QtMobility::QContactDetailRangeFilter::rangeFlags();
            pyResult = Shiboken::Converter<QFlags<QtMobility::QContactDetailRangeFilter::RangeFlag> >::toPython(cppResult);
            }
        }
        }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return 0;
    }
    return pyResult;
}

static PyObject* SbkQtMobility_QContactDetailRangeFilterFunc_setDetailDefinitionName(PyObject* self, PyObject* args, PyObject* kwds)
{
    QtMobility::QContactDetailRangeFilter* cppSelf = 0;
    if (Shiboken::cppObjectIsInvalid(self))
        return 0;
    cppSelf = Shiboken::Converter<QtMobility::QContactDetailRangeFilter* >::toCpp(self);

    int overloadId = -1;
    std::vector<PyObject*> propertyKeys;

    // Check existence of named argument.
    if (kwds) {
        std::string argNames[] = { "fieldName" };
        PyObject* keys = PyDict_Keys(kwds);
        Shiboken::AutoDecRef auto_keys(keys);
        for (int i = 0; i < PyList_GET_SIZE(keys); ++i) {
            PyObject* argName = PyList_GET_ITEM(keys, i);
            if (!std::binary_search(argNames, argNames + 1, std::string(PyString_AS_STRING(argName)))) {
                PyErr_Format(PyExc_TypeError, "QtMobility.Contacts.QContactDetailRangeFilter.setDetailDefinitionName(): got an unexpected keyword argument '%s'", PyString_AS_STRING(argName));
                return 0;
            }
        }
    }
    int numNamedArgs = (kwds ? PyDict_Size(kwds) : 0);
    int numArgs = PyTuple_GET_SIZE(args);
    PyObject* pyargs[] = {0, 0};

    // invalid argument lengths
    if (numArgs + numNamedArgs > 2) {
        PyErr_SetString(PyExc_TypeError, "QtMobility.Contacts.QContactDetailRangeFilter.setDetailDefinitionName(): too many arguments");
        return 0;
    } else if (numArgs < 1) {
        PyErr_SetString(PyExc_TypeError, "QtMobility.Contacts.QContactDetailRangeFilter.setDetailDefinitionName(): not enough arguments");
        return 0;
    }

    if (!PyArg_ParseTuple(args, "|OO:setDetailDefinitionName", &(pyargs[0]), &(pyargs[1])))
        return 0;


    // Overloaded function decisor
    // 0: setDetailDefinitionName(QString,QString)
    if (Shiboken::Converter<QString >::isConvertible(pyargs[0])) {
        if (numArgs == 1) {
            overloadId = 0; // setDetailDefinitionName(QString,QString)
        } else if (Shiboken::Converter<QString >::isConvertible(pyargs[1])) {
            overloadId = 0; // setDetailDefinitionName(QString,QString)
        }
    }

    // Function signature not found.
    if (overloadId == -1) goto SbkQtMobility_QContactDetailRangeFilterFunc_setDetailDefinitionName_TypeError;

    // Call function/method
    {
        {
            if (kwds) {
                const char* errorArgName = 0;
                PyObject* value = PyDict_GetItemString(kwds, "fieldName");
                if (value) {
                    if (pyargs[1])
                        errorArgName = "fieldName";
                    else
                        pyargs[1] = value;
                }
                if (errorArgName) {
                    PyErr_Format(PyExc_TypeError, "QtMobility.Contacts.QContactDetailRangeFilter.setDetailDefinitionName(): got multiple values for keyword argument '%s'", errorArgName);
                    return 0;
                }
            }
            QString cpp_arg0 = Shiboken::Converter<QString >::toCpp(pyargs[0]);
            QString cpp_arg1 = pyargs[1] ? Shiboken::Converter<QString >::toCpp(pyargs[1]) : QString();

            if(!PyErr_Occurred()) {
            // setDetailDefinitionName(QString,QString)
            cppSelf->QtMobility::QContactDetailRangeFilter::setDetailDefinitionName(cpp_arg0, cpp_arg1);
            }
        }
        }

    if (PyErr_Occurred()) {
        return 0;
    }
    Py_RETURN_NONE;

    SbkQtMobility_QContactDetailRangeFilterFunc_setDetailDefinitionName_TypeError:
        const char* overloads[] = {"QString, QString = QString()", 0};
        Shiboken::setErrorAboutWrongArguments(args, "QtMobility.Contacts.QContactDetailRangeFilter.setDetailDefinitionName", overloads);
        return 0;
}

static PyObject* SbkQtMobility_QContactDetailRangeFilterFunc_setMatchFlags(PyObject* self, PyObject* arg)
{
    QtMobility::QContactDetailRangeFilter* cppSelf = 0;
    if (Shiboken::cppObjectIsInvalid(self))
        return 0;
    cppSelf = Shiboken::Converter<QtMobility::QContactDetailRangeFilter* >::toCpp(self);

    int overloadId = -1;

    // Overloaded function decisor
    // 0: setMatchFlags(QFlags<QtMobility::QContactFilter::MatchFlag>)
    if (Shiboken::Converter<QFlags<QtMobility::QContactFilter::MatchFlag> >::isConvertible(arg)) {
        overloadId = 0; // setMatchFlags(QFlags<QtMobility::QContactFilter::MatchFlag>)
    }

    // Function signature not found.
    if (overloadId == -1) goto SbkQtMobility_QContactDetailRangeFilterFunc_setMatchFlags_TypeError;

    // Call function/method
    {
        {
            QFlags<QtMobility::QContactFilter::MatchFlag> cpp_arg0 = Shiboken::Converter<QFlags<QtMobility::QContactFilter::MatchFlag> >::toCpp(arg);

            if(!PyErr_Occurred()) {
            // setMatchFlags(QFlags<QtMobility::QContactFilter::MatchFlag>)
            cppSelf->QtMobility::QContactDetailRangeFilter::setMatchFlags(cpp_arg0);
            }
        }
        }

    if (PyErr_Occurred()) {
        return 0;
    }
    Py_RETURN_NONE;

    SbkQtMobility_QContactDetailRangeFilterFunc_setMatchFlags_TypeError:
        const char* overloads[] = {"QtMobility.Contacts.QtMobility::QContactFilter.MatchFlags", 0};
        Shiboken::setErrorAboutWrongArguments(arg, "QtMobility.Contacts.QContactDetailRangeFilter.setMatchFlags", overloads);
        return 0;
}

static PyObject* SbkQtMobility_QContactDetailRangeFilterFunc_setRange(PyObject* self, PyObject* args, PyObject* kwds)
{
    QtMobility::QContactDetailRangeFilter* cppSelf = 0;
    if (Shiboken::cppObjectIsInvalid(self))
        return 0;
    cppSelf = Shiboken::Converter<QtMobility::QContactDetailRangeFilter* >::toCpp(self);

    int overloadId = -1;
    std::vector<PyObject*> propertyKeys;

    // Check existence of named argument.
    if (kwds) {
        std::string argNames[] = { "flags" };
        PyObject* keys = PyDict_Keys(kwds);
        Shiboken::AutoDecRef auto_keys(keys);
        for (int i = 0; i < PyList_GET_SIZE(keys); ++i) {
            PyObject* argName = PyList_GET_ITEM(keys, i);
            if (!std::binary_search(argNames, argNames + 1, std::string(PyString_AS_STRING(argName)))) {
                PyErr_Format(PyExc_TypeError, "QtMobility.Contacts.QContactDetailRangeFilter.setRange(): got an unexpected keyword argument '%s'", PyString_AS_STRING(argName));
                return 0;
            }
        }
    }
    int numNamedArgs = (kwds ? PyDict_Size(kwds) : 0);
    int numArgs = PyTuple_GET_SIZE(args);
    PyObject* pyargs[] = {0, 0, 0};

    // invalid argument lengths
    if (numArgs + numNamedArgs > 3) {
        PyErr_SetString(PyExc_TypeError, "QtMobility.Contacts.QContactDetailRangeFilter.setRange(): too many arguments");
        return 0;
    } else if (numArgs < 2) {
        PyErr_SetString(PyExc_TypeError, "QtMobility.Contacts.QContactDetailRangeFilter.setRange(): not enough arguments");
        return 0;
    }

    if (!PyArg_ParseTuple(args, "|OOO:setRange", &(pyargs[0]), &(pyargs[1]), &(pyargs[2])))
        return 0;


    // Overloaded function decisor
    // 0: setRange(QVariant,QVariant,QFlags<QtMobility::QContactDetailRangeFilter::RangeFlag>)
    if (numArgs >= 2 && Shiboken::Converter<QVariant >::isConvertible(pyargs[0]) && Shiboken::Converter<QVariant >::isConvertible(pyargs[1])) {
        if (numArgs == 2) {
            overloadId = 0; // setRange(QVariant,QVariant,QFlags<QtMobility::QContactDetailRangeFilter::RangeFlag>)
        } else if (Shiboken::Converter<QFlags<QtMobility::QContactDetailRangeFilter::RangeFlag> >::isConvertible(pyargs[2])) {
            overloadId = 0; // setRange(QVariant,QVariant,QFlags<QtMobility::QContactDetailRangeFilter::RangeFlag>)
        }
    }

    // Function signature not found.
    if (overloadId == -1) goto SbkQtMobility_QContactDetailRangeFilterFunc_setRange_TypeError;

    // Call function/method
    {
        {
            if (kwds) {
                const char* errorArgName = 0;
                PyObject* value = PyDict_GetItemString(kwds, "flags");
                if (value) {
                    if (pyargs[2])
                        errorArgName = "flags";
                    else
                        pyargs[2] = value;
                }
                if (errorArgName) {
                    PyErr_Format(PyExc_TypeError, "QtMobility.Contacts.QContactDetailRangeFilter.setRange(): got multiple values for keyword argument '%s'", errorArgName);
                    return 0;
                }
            }
            QVariant cpp_arg0 = Shiboken::Converter<QVariant >::toCpp(pyargs[0]);
            QVariant cpp_arg1 = Shiboken::Converter<QVariant >::toCpp(pyargs[1]);
            QFlags<QtMobility::QContactDetailRangeFilter::RangeFlag> cpp_arg2 = pyargs[2] ? Shiboken::Converter<QFlags<QtMobility::QContactDetailRangeFilter::RangeFlag> >::toCpp(pyargs[2]) : QFlags<QtMobility::QContactDetailRangeFilter::RangeFlag>(0);

            if(!PyErr_Occurred()) {
            // setRange(QVariant,QVariant,QFlags<QtMobility::QContactDetailRangeFilter::RangeFlag>)
            cppSelf->QtMobility::QContactDetailRangeFilter::setRange(cpp_arg0, cpp_arg1, cpp_arg2);
            }
        }
        }

    if (PyErr_Occurred()) {
        return 0;
    }
    Py_RETURN_NONE;

    SbkQtMobility_QContactDetailRangeFilterFunc_setRange_TypeError:
        const char* overloads[] = {"QVariant, QVariant, QtMobility.Contacts.QtMobility::QContactDetailRangeFilter.RangeFlags = 0", 0};
        Shiboken::setErrorAboutWrongArguments(args, "QtMobility.Contacts.QContactDetailRangeFilter.setRange", overloads);
        return 0;
}

static PyMethodDef SbkQtMobility_QContactDetailRangeFilter_methods[] = {
    {"detailDefinitionName", (PyCFunction)SbkQtMobility_QContactDetailRangeFilterFunc_detailDefinitionName, METH_NOARGS},
    {"detailFieldName", (PyCFunction)SbkQtMobility_QContactDetailRangeFilterFunc_detailFieldName, METH_NOARGS},
    {"matchFlags", (PyCFunction)SbkQtMobility_QContactDetailRangeFilterFunc_matchFlags, METH_NOARGS},
    {"maxValue", (PyCFunction)SbkQtMobility_QContactDetailRangeFilterFunc_maxValue, METH_NOARGS},
    {"minValue", (PyCFunction)SbkQtMobility_QContactDetailRangeFilterFunc_minValue, METH_NOARGS},
    {"rangeFlags", (PyCFunction)SbkQtMobility_QContactDetailRangeFilterFunc_rangeFlags, METH_NOARGS},
    {"setDetailDefinitionName", (PyCFunction)SbkQtMobility_QContactDetailRangeFilterFunc_setDetailDefinitionName, METH_VARARGS|METH_KEYWORDS},
    {"setMatchFlags", (PyCFunction)SbkQtMobility_QContactDetailRangeFilterFunc_setMatchFlags, METH_O},
    {"setRange", (PyCFunction)SbkQtMobility_QContactDetailRangeFilterFunc_setRange, METH_VARARGS|METH_KEYWORDS},
    {0} // Sentinel
};

} // extern "C"

// Class Definition -----------------------------------------------
extern "C" {
static SbkBaseWrapperType SbkQtMobility_QContactDetailRangeFilter_Type = { { {
    PyObject_HEAD_INIT(&Shiboken::SbkBaseWrapperType_Type)
    /*ob_size*/             0,
    /*tp_name*/             "QtMobility.Contacts.QContactDetailRangeFilter",
    /*tp_basicsize*/        sizeof(Shiboken::SbkBaseWrapper),
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          &Shiboken::deallocWrapper,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        0,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_CHECKTYPES,
    /*tp_doc*/              0,
    /*tp_traverse*/         0,
    /*tp_clear*/            0,
    /*tp_richcompare*/      0,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          SbkQtMobility_QContactDetailRangeFilter_methods,
    /*tp_members*/          0,
    /*tp_getset*/           0,
    /*tp_base*/             0,
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             SbkQtMobility_QContactDetailRangeFilter_Init,
    /*tp_alloc*/            0,
    /*tp_new*/              Shiboken::SbkBaseWrapper_TpNew,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
}, },
    /*mi_offsets*/          0,
    /*mi_init*/             0,
    /*mi_specialcast*/      0,
    /*type_discovery*/      0,
    /*obj_copier*/          0,
    /*ext_isconvertible*/   0,
    /*ext_tocpp*/           0,
    /*cpp_dtor*/            &Shiboken::callCppDestructor<QtMobility::QContactDetailRangeFilter >,
    /*is_multicpp*/         0,
    /*is_user_type*/        0,
    /*original_name*/       "QtMobility::QContactDetailRangeFilter",
    /*user_data*/           0
};
} //extern

PyObject* SbkQtMobility_Contacts_QtMobility_QContactDetailRangeFilter_RangeFlag___and__(PyObject* self, PyObject* arg)
{
    if (Shiboken::Converter<QtMobility::QContactDetailRangeFilter::RangeFlags >::checkType(self) && Shiboken::Converter<QtMobility::QContactDetailRangeFilter::RangeFlags >::checkType(arg))
    {
        PyErr_Format(PyExc_TypeError, "unsupported operand type(s) for %s: '%s' and '%s'", "&", self->ob_type->tp_name, arg->ob_type->tp_name);
        return 0;
    }

    return Shiboken::Converter< QtMobility::QContactDetailRangeFilter::RangeFlags >::toPython(
        Shiboken::Converter<QtMobility::QContactDetailRangeFilter::RangeFlags>::toCpp(self)
        & Shiboken::Converter< QtMobility::QContactDetailRangeFilter::RangeFlags >::toCpp(arg)
    );
}

PyObject* SbkQtMobility_Contacts_QtMobility_QContactDetailRangeFilter_RangeFlag___or__(PyObject* self, PyObject* arg)
{
    if (Shiboken::Converter<QtMobility::QContactDetailRangeFilter::RangeFlags >::checkType(self) && Shiboken::Converter<QtMobility::QContactDetailRangeFilter::RangeFlags >::checkType(arg))
    {
        PyErr_Format(PyExc_TypeError, "unsupported operand type(s) for %s: '%s' and '%s'", "|", self->ob_type->tp_name, arg->ob_type->tp_name);
        return 0;
    }

    return Shiboken::Converter< QtMobility::QContactDetailRangeFilter::RangeFlags >::toPython(
        Shiboken::Converter<QtMobility::QContactDetailRangeFilter::RangeFlags>::toCpp(self)
        | Shiboken::Converter< QtMobility::QContactDetailRangeFilter::RangeFlags >::toCpp(arg)
    );
}

PyObject* SbkQtMobility_Contacts_QtMobility_QContactDetailRangeFilter_RangeFlag___xor__(PyObject* self, PyObject* arg)
{
    if (Shiboken::Converter<QtMobility::QContactDetailRangeFilter::RangeFlags >::checkType(self) && Shiboken::Converter<QtMobility::QContactDetailRangeFilter::RangeFlags >::checkType(arg))
    {
        PyErr_Format(PyExc_TypeError, "unsupported operand type(s) for %s: '%s' and '%s'", "^", self->ob_type->tp_name, arg->ob_type->tp_name);
        return 0;
    }

    return Shiboken::Converter< QtMobility::QContactDetailRangeFilter::RangeFlags >::toPython(
        Shiboken::Converter<QtMobility::QContactDetailRangeFilter::RangeFlags>::toCpp(self)
        ^ Shiboken::Converter< QtMobility::QContactDetailRangeFilter::RangeFlags >::toCpp(arg)
    );
}

PyObject* SbkQtMobility_Contacts_QtMobility_QContactDetailRangeFilter_RangeFlag___invert__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< QtMobility::QContactDetailRangeFilter::RangeFlags >::toPython(
        ~Shiboken::Converter<QtMobility::QContactDetailRangeFilter::RangeFlags >::toCpp(self)
    );
}


static PyNumberMethods SbkQtMobility_Contacts_QtMobility_QContactDetailRangeFilter_RangeFlag_as_number = {
    /*nb_add*/                  0,
    /*nb_subtract*/             0,
    /*nb_multiply*/             0,
    /*nb_divide*/               0,
    /*nb_remainder*/            0,
    /*nb_divmod*/               0,
    /*nb_power*/                0,
    /*nb_negative*/             0,
    /*nb_positive*/             0,
    /*nb_absolute*/             0,
    /*nb_nonzero*/              0,
    /*nb_invert*/               (unaryfunc)SbkQtMobility_Contacts_QtMobility_QContactDetailRangeFilter_RangeFlag___invert__,
    /*nb_lshift*/               0,
    /*nb_rshift*/               0,
    /*nb_and*/                  (binaryfunc)SbkQtMobility_Contacts_QtMobility_QContactDetailRangeFilter_RangeFlag___and__,
    /*nb_xor*/                  (binaryfunc)SbkQtMobility_Contacts_QtMobility_QContactDetailRangeFilter_RangeFlag___xor__,
    /*nb_or*/                   (binaryfunc)SbkQtMobility_Contacts_QtMobility_QContactDetailRangeFilter_RangeFlag___or__,
    /*nb_coerce*/               0,
    /*nb_int*/                  0,
    /*nb_long*/                 0,
    /*nb_float*/                0,
    /*nb_oct*/                  0,
    /*nb_hex*/                  0,
    /*nb_inplace_add*/          0,
    /*nb_inplace_subtract*/     0,
    /*nb_inplace_multiply*/     0,
    /*nb_inplace_divide*/       0,
    /*nb_inplace_remainder*/    0,
    /*nb_inplace_power*/        0,
    /*nb_inplace_lshift*/       0,
    /*nb_inplace_rshift*/       0,
    /*nb_inplace_and*/          0,
    /*nb_inplace_xor*/          0,
    /*nb_inplace_or*/           0,
    /*nb_floor_divide*/         0,
    /*nb_true_divide*/          0,
    /*nb_inplace_floor_divide*/ 0,
    /*nb_inplace_true_divide*/  0,
    /*nb_index*/                0
};


static PyGetSetDef SbkQtMobility_Contacts_QtMobility_QContactDetailRangeFilter_RangeFlag_getsetlist[] = {
    {const_cast<char*>("name"), (getter)Shiboken::SbkEnumObject_name},
    {0}  // Sentinel
};

// forward declaration of new function
static PyObject* SbkQtMobility_Contacts_QtMobility_QContactDetailRangeFilter_RangeFlag_New(PyTypeObject*, PyObject*, PyObject*);

static PyTypeObject SbkQtMobility_Contacts_QtMobility_QContactDetailRangeFilter_RangeFlag_Type = {
    PyObject_HEAD_INIT(&Shiboken::SbkEnumType_Type)
    /*ob_size*/             0,
    /*tp_name*/             "RangeFlag",
    /*tp_basicsize*/        sizeof(Shiboken::SbkEnumObject),
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          0,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             Shiboken::SbkEnumObject_repr,
    /*tp_as_number*/        &SbkQtMobility_Contacts_QtMobility_QContactDetailRangeFilter_RangeFlag_as_number,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              Shiboken::SbkEnumObject_repr,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT,
    /*tp_doc*/              0,
    /*tp_traverse*/         0,
    /*tp_clear*/            0,
    /*tp_richcompare*/      0,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          0,
    /*tp_members*/          0,
    /*tp_getset*/           SbkQtMobility_Contacts_QtMobility_QContactDetailRangeFilter_RangeFlag_getsetlist,
    /*tp_base*/             &PyInt_Type,
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             0,
    /*tp_alloc*/            0,
    /*tp_new*/              SbkQtMobility_Contacts_QtMobility_QContactDetailRangeFilter_RangeFlag_New,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
};

static PyObject* SbkQtMobility_Contacts_QtMobility_QContactDetailRangeFilter_RangeFlag_New(PyTypeObject* type, PyObject* args, PyObject* kwds)
{
    int item_value = 0;
    if (!PyArg_ParseTuple(args, "|i:__new__", &item_value))
        return 0;
    PyObject* self = Shiboken::SbkEnumObject_New(type, item_value);

    if (!self)
        return 0;
    return self;
}

// forward declaration of new function
static PyTypeObject SbkQtMobility_Contacts_QtMobility_QContactDetailRangeFilter_RangeFlags_Type = {
    PyObject_HEAD_INIT(&PyType_Type)
    /*ob_size*/             0,
    /*tp_name*/             "RangeFlags",
    /*tp_basicsize*/        0,
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          0,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        SbkQtMobility_Contacts_QtMobility_QContactDetailRangeFilter_RangeFlag_Type.tp_as_number,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT | Py_TPFLAGS_CHECKTYPES,
    /*tp_doc*/              0,
    /*tp_traverse*/         0,
    /*tp_clear*/            0,
    /*tp_richcompare*/      0,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          0,
    /*tp_members*/          0,
    /*tp_getset*/           0,
    /*tp_base*/             &PyInt_Type,
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             0,
    /*tp_alloc*/            0,
    /*tp_new*/              PyInt_Type.tp_new,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
};



void init_QtMobility_QContactDetailRangeFilter(PyObject* module)
{
    SbkQtMobility_ContactsTypes[SBK_QTMOBILITY_QCONTACTDETAILRANGEFILTER_IDX] = reinterpret_cast<PyTypeObject*>(&SbkQtMobility_QContactDetailRangeFilter_Type);

    SbkQtMobility_QContactDetailRangeFilter_Type.super.ht_type.tp_base = SbkQtMobility_ContactsTypes[SBK_QTMOBILITY_QCONTACTFILTER_IDX];
    if (PyType_Ready((PyTypeObject*)&SbkQtMobility_QContactDetailRangeFilter_Type) < 0)
        return;

    Py_INCREF(reinterpret_cast<PyObject*>(&SbkQtMobility_QContactDetailRangeFilter_Type));
    PyModule_AddObject(module, "QContactDetailRangeFilter",
        ((PyObject*)&SbkQtMobility_QContactDetailRangeFilter_Type));

    // Initialize enums
    PyObject* enum_item;

    // init enum class: RangeFlag
    SbkQtMobility_ContactsTypes[SBK_QTMOBILITY_QCONTACTDETAILRANGEFILTER_RANGEFLAG_IDX] = &SbkQtMobility_Contacts_QtMobility_QContactDetailRangeFilter_RangeFlag_Type;
    if (PyType_Ready((PyTypeObject*)&SbkQtMobility_Contacts_QtMobility_QContactDetailRangeFilter_RangeFlag_Type) < 0)
        return;
    Py_INCREF(&SbkQtMobility_Contacts_QtMobility_QContactDetailRangeFilter_RangeFlag_Type);
    PyDict_SetItemString(SbkQtMobility_QContactDetailRangeFilter_Type.super.ht_type.tp_dict,
            "RangeFlag",((PyObject*)&SbkQtMobility_Contacts_QtMobility_QContactDetailRangeFilter_RangeFlag_Type));

    // init flags class: QFlags<QtMobility::QContactDetailRangeFilter::RangeFlag>
    SbkQtMobility_ContactsTypes[SBK_QFLAGS_QTMOBILITY_QCONTACTDETAILRANGEFILTER_RANGEFLAG__IDX] = &SbkQtMobility_Contacts_QtMobility_QContactDetailRangeFilter_RangeFlags_Type;
    if (PyType_Ready((PyTypeObject*)&SbkQtMobility_Contacts_QtMobility_QContactDetailRangeFilter_RangeFlags_Type) < 0)
        return;
    Py_INCREF(&SbkQtMobility_Contacts_QtMobility_QContactDetailRangeFilter_RangeFlags_Type);
    PyDict_SetItemString(SbkQtMobility_QContactDetailRangeFilter_Type.super.ht_type.tp_dict,
            "RangeFlags",((PyObject*)&SbkQtMobility_Contacts_QtMobility_QContactDetailRangeFilter_RangeFlags_Type));

    enum_item = Shiboken::SbkEnumObject_New(&SbkQtMobility_Contacts_QtMobility_QContactDetailRangeFilter_RangeFlag_Type,
        (long) QtMobility::QContactDetailRangeFilter::IncludeLower, "IncludeLower");
    PyDict_SetItemString(SbkQtMobility_QContactDetailRangeFilter_Type.super.ht_type.tp_dict,
        "IncludeLower", enum_item);
    PyDict_SetItemString(SbkQtMobility_Contacts_QtMobility_QContactDetailRangeFilter_RangeFlag_Type.tp_dict,
        "IncludeLower", enum_item);
    enum_item = Shiboken::SbkEnumObject_New(&SbkQtMobility_Contacts_QtMobility_QContactDetailRangeFilter_RangeFlag_Type,
        (long) QtMobility::QContactDetailRangeFilter::IncludeUpper, "IncludeUpper");
    PyDict_SetItemString(SbkQtMobility_QContactDetailRangeFilter_Type.super.ht_type.tp_dict,
        "IncludeUpper", enum_item);
    PyDict_SetItemString(SbkQtMobility_Contacts_QtMobility_QContactDetailRangeFilter_RangeFlag_Type.tp_dict,
        "IncludeUpper", enum_item);
    enum_item = Shiboken::SbkEnumObject_New(&SbkQtMobility_Contacts_QtMobility_QContactDetailRangeFilter_RangeFlag_Type,
        (long) QtMobility::QContactDetailRangeFilter::ExcludeLower, "ExcludeLower");
    PyDict_SetItemString(SbkQtMobility_QContactDetailRangeFilter_Type.super.ht_type.tp_dict,
        "ExcludeLower", enum_item);
    PyDict_SetItemString(SbkQtMobility_Contacts_QtMobility_QContactDetailRangeFilter_RangeFlag_Type.tp_dict,
        "ExcludeLower", enum_item);
    enum_item = Shiboken::SbkEnumObject_New(&SbkQtMobility_Contacts_QtMobility_QContactDetailRangeFilter_RangeFlag_Type,
        (long) QtMobility::QContactDetailRangeFilter::ExcludeUpper, "ExcludeUpper");
    PyDict_SetItemString(SbkQtMobility_QContactDetailRangeFilter_Type.super.ht_type.tp_dict,
        "ExcludeUpper", enum_item);
    PyDict_SetItemString(SbkQtMobility_Contacts_QtMobility_QContactDetailRangeFilter_RangeFlag_Type.tp_dict,
        "ExcludeUpper", enum_item);
    Shiboken::TypeResolver::createValueTypeResolver<int>("QtMobility::QContactDetailRangeFilter::RangeFlag");


    Shiboken::TypeResolver::createValueTypeResolver<QtMobility::QContactDetailRangeFilter >("QtMobility::QContactDetailRangeFilter");
    Shiboken::TypeResolver::createObjectTypeResolver<QtMobility::QContactDetailRangeFilter >("QtMobility::QContactDetailRangeFilter*");
    Shiboken::TypeResolver::createValueTypeResolver<QtMobility::QContactDetailRangeFilter >(typeid(QtMobility::QContactDetailRangeFilter).name());
    PySide::initQtMetaType<QtMobility::QContactDetailRangeFilter >();
}

